/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// WhatsAppTemplateHeaderFormat the model 'WhatsAppTemplateHeaderFormat'
type WhatsAppTemplateHeaderFormat string

// List of WhatsAppTemplateHeaderFormat
const (
	WhatsAppTemplateHeaderFormatText WhatsAppTemplateHeaderFormat = "TEXT"
	WhatsAppTemplateHeaderFormatImage WhatsAppTemplateHeaderFormat = "IMAGE"
	WhatsAppTemplateHeaderFormatDocument WhatsAppTemplateHeaderFormat = "DOCUMENT"
	WhatsAppTemplateHeaderFormatVideo WhatsAppTemplateHeaderFormat = "VIDEO"
)

// All allowed values of WhatsAppTemplateHeaderFormat enum
var AllowedWhatsAppTemplateHeaderFormatEnumValues = []WhatsAppTemplateHeaderFormat{
	"TEXT",
	"IMAGE",
	"DOCUMENT",
	"VIDEO",
}

func (v *WhatsAppTemplateHeaderFormat) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := WhatsAppTemplateHeaderFormat(value)
	for _, existing := range AllowedWhatsAppTemplateHeaderFormatEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid WhatsAppTemplateHeaderFormat", value)
}

// NewWhatsAppTemplateHeaderFormatFromValue returns a pointer to a valid WhatsAppTemplateHeaderFormat
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewWhatsAppTemplateHeaderFormatFromValue(v string) (*WhatsAppTemplateHeaderFormat, error) {
	ev := WhatsAppTemplateHeaderFormat(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for WhatsAppTemplateHeaderFormat: valid values are %v", v, AllowedWhatsAppTemplateHeaderFormatEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v WhatsAppTemplateHeaderFormat) IsValid() bool {
	for _, existing := range AllowedWhatsAppTemplateHeaderFormatEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to WhatsAppTemplateHeaderFormat value
func (v WhatsAppTemplateHeaderFormat) Ptr() *WhatsAppTemplateHeaderFormat {
	return &v
}

type NullableWhatsAppTemplateHeaderFormat struct {
	value *WhatsAppTemplateHeaderFormat
	isSet bool
}

func (v NullableWhatsAppTemplateHeaderFormat) Get() *WhatsAppTemplateHeaderFormat {
	return v.value
}

func (v *NullableWhatsAppTemplateHeaderFormat) Set(val *WhatsAppTemplateHeaderFormat) {
	v.value = val
	v.isSet = true
}

func (v NullableWhatsAppTemplateHeaderFormat) IsSet() bool {
	return v.isSet
}

func (v *NullableWhatsAppTemplateHeaderFormat) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWhatsAppTemplateHeaderFormat(val *WhatsAppTemplateHeaderFormat) *NullableWhatsAppTemplateHeaderFormat {
	return &NullableWhatsAppTemplateHeaderFormat{value: val, isSet: true}
}

func (v NullableWhatsAppTemplateHeaderFormat) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWhatsAppTemplateHeaderFormat) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

